import 'dart:async';

import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:wyatt_crud_bloc/wyatt_crud_bloc.dart';

class ExampleCubit extends Cubit<CrudState> {
  ExampleCubit() : super(const CrudInitial());

  FutureOr<void> run() async {
    while (true) {
      await Future<void>.delayed(const Duration(seconds: 1));
      emit(const CrudLoading());
      await Future<void>.delayed(const Duration(seconds: 1));
      emit(const CrudError('Cubit Error'));
      await Future<void>.delayed(const Duration(seconds: 1));
      emit(const CrudLoaded<String>('DATA LOADED'));
      await Future<void>.delayed(const Duration(seconds: 1));
      emit(const CrudInitial());
    }
  }

  FutureOr<void> runList() async {
    while (true) {
      await Future<void>.delayed(const Duration(seconds: 1));
      emit(const CrudLoading());
      await Future<void>.delayed(const Duration(seconds: 1));
      emit(const CrudError('Cubit Error'));
      await Future<void>.delayed(const Duration(seconds: 1));
      emit(
        const CrudListLoaded<String>([
          'DATA LOADED 1',
          'DATA LOADED 2',
          'DATA LOADED 3',
          'DATA LOADED 4'
        ]),
      );
      await Future<void>.delayed(const Duration(seconds: 1));
      emit(const CrudInitial());
    }
  }
}
