// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter/material.dart';
import 'package:wyatt_component_copy_with_extension/wyatt_component_copy_with_extension.dart';
import 'package:wyatt_ui_components/wyatt_ui_components.dart';

part 'floating_action_button_component.g.dart';

@ComponentProxyExtension()
abstract class FloatingActionButtonComponent extends Component
    with CopyWithMixin<$FloatingActionButtonComponentCWProxy> {
  const FloatingActionButtonComponent({
    this.child,
    this.tooltip,
    this.foregroundColor,
    this.backgroundColor,
    this.focusColor,
    this.hoverColor,
    this.splashColor,
    this.heroTag,
    this.onPressed,
    this.mouseCursor,
    this.elevation,
    this.focusElevation,
    this.hoverElevation,
    this.highlightElevation,
    this.disabledElevation,
    this.mini,
    this.shape,
    this.clipBehavior,
    this.isExtended,
    this.focusNode,
    this.autofocus,
    this.materialTapTargetSize,
    this.enableFeedback,
    this.extendedIconLabelSpacing,
    this.extendedPadding,
    this.extendedTextStyle,
    super.key,
  });

  final Widget? child;

  final String? tooltip;

  final Color? foregroundColor;

  final Color? backgroundColor;

  final Color? focusColor;

  final Color? hoverColor;

  final Color? splashColor;

  final Object? heroTag;

  final VoidCallback? onPressed;

  final MouseCursor? mouseCursor;

  final double? elevation;

  final double? focusElevation;

  final double? hoverElevation;

  final double? highlightElevation;

  final double? disabledElevation;

  final bool? mini;

  final ShapeBorder? shape;

  final Clip? clipBehavior;

  final bool? isExtended;

  final FocusNode? focusNode;

  final bool? autofocus;

  final MaterialTapTargetSize? materialTapTargetSize;

  final bool? enableFeedback;

  final double? extendedIconLabelSpacing;

  final EdgeInsetsGeometry? extendedPadding;

  final TextStyle? extendedTextStyle;
}
